<?php
class console_finder_vopick{

    var $addon_cols    ='status,delivery_status,to_branch_bn';
    
    var $column_to_branch_bn = '入库仓库';
    var $column_to_branch_bn_width = '100';
    var $column_to_branch_bn_order = 14;
    function column_to_branch_bn($row)
    {
        if($row[$this->col_prefix .'to_branch_bn'])
        {
            $purchaseLib    = kernel::single('purchase_purchase_order');
            $branchInfo     = $purchaseLib->getWarehouse($row[$this->col_prefix .'to_branch_bn']);
            
            $row[$this->col_prefix .'to_branch_bn']    = $branchInfo['branch_name'];
        }
        
        return $row[$this->col_prefix .'to_branch_bn'];
    }
    
    var $column_status = '审核状态';
    var $column_status_width = '100';
    var $column_status_order = 14;
    function column_status($row)
    {
        return ($row[$this->col_prefix .'status'] == 2 ? '已审核' : '未审核');
    }
    
    var $column_delivery_status = '发贷状态';
    var $column_delivery_status_width = '100';
    var $column_delivery_status_order = 14;
    function column_delivery_status($row)
    {
        return ($row[$this->col_prefix .'delivery_status'] == 2 ? '已发货' : '未发货');
    }
    
    var $column_edit  = '操作';
    var $column_edit_order = 2;
    var $column_edit_width = '150';
    function column_edit($row)
    {
        $bill_id     = $row['bill_id'];
        $finder_id   = $_GET['_finder']['finder_id'];
        
        $button    = <<<EOF
            <a class="lnk" href="index.php?app=console&ctl=admin_vopick&act=recheck&p[0]=$bill_id&_finder[finder_id]=$finder_id&finder_id=$finder_id" target="_blank">补发</a>
EOF;
        
        if($row[$this->col_prefix .'status'] == '2')
        {
            if($row[$this->col_prefix .'delivery_status']==2 && ($row['pick_num'] > $row['branch_send_num']))
            {
                //检查是否存在未完成的出库单
                $stockoutObj = app::get('purchase')->model('pick_stockout_bills');
                
                $sql        = "SELECT a.stockout_id FROM sdb_purchase_pick_stockout AS a LEFT JOIN sdb_purchase_pick_stockout_bills AS b
                               ON a.stockout_id=b.stockout_id WHERE a.bill_id=". $bill_id ." AND (b.status=1 OR b.o_status=1)";
                $stockRow   = $stockoutObj->db->selectrow($sql);
                if(empty($stockRow))
                {
                    return '<span class="c-gray">'. $button .'</span>';
                }
            }
            
            return '';
        }
        
        $button    = <<<EOF
            <a class="lnk" href="index.php?app=console&ctl=admin_vopick&act=check&p[0]=$bill_id&_finder[finder_id]=$finder_id&finder_id=$finder_id" target="_blank">审核</a>
EOF;
        
        return '<span class="c-gray">'. $button .'</span>';
    }
    
    var $detail_base = '拣货单详情';
    public function detail_base($bill_id)
    {
        $render = app::get('console')->render();
        
        //详情
        $pickObj    = app::get('purchase')->model('pick_bills');
        $row        = $pickObj->dump(array('bill_id'=>$bill_id), '*');
        
        $row['status']           = $row['status'] == '2' ? '已审核' : '未审核';
        $row['delivery_status']  = $row['delivery_status'] == '2' ? '已发货' : '未发货';
        $row['create_time']      = date('Y-m-d H:i:s', $row['create_time']);
        
        if($row['to_branch_bn'])
        {
            $purchaseLib    = kernel::single('purchase_purchase_order');
            $branchInfo     = $purchaseLib->getWarehouse($row['to_branch_bn']);
            
            $row['branch_name']    = $branchInfo['branch_name'];
        }
        
        $render->pagedata['data']    = $row;
        return $render->fetch('admin/vop/vopick_detail.html');
    }
    
    var $detail_items = '拣货单明细';
    public function detail_items($bill_id)
    {
        $render = app::get('console')->render();
        
        //详情
        $pickObj    = app::get('purchase')->model('pick_bills');
        $pick_info  = $pickObj->dump(array('bill_id'=>$bill_id), ' bill_id, status');
        
        $render->pagedata['is_stockout']    = ($pick_info['status'] == 2 ? true : false);
        $render->pagedata['pick_info']    = $pick_info;
        return $render->fetch('admin/vop/vopick_item.html');
    }
    
    var $detail_logs = '操作日志';
    public function detail_logs($bill_id)
    {
        $render = app::get('console')->render();
        
        $logObj = app::get('ome')->model('operation_log');
        
        $logs    = $logObj->read_log(array('obj_id'=>$bill_id, 'obj_type'=>'pick_bills@purchase'), 0, -1);
        foreach($logs as $k=>$v)
        {
            $logs[$k]['operate_time']    = date('Y-m-d H:i:s', $v['operate_time']);
        }
        
        $render->pagedata['logs']    = $logs;
        return $render->fetch('admin/vop/logs.html');
    }
}