<?php
class erpapi_shop_request_logistics extends erpapi_shop_request_abstract
{
    

    #菜鸟流转订单处理规则同步
    public  function syncOrderRule($sdf){
        $params['shop_code'] = $sdf['shop_code'];
        $params['is_open_cnauto'] =$sdf['is_open_cnauto'];
        $params['is_auto_check'] =  $sdf['is_auto_check'];
        $params['check_rule_msg'] =  $sdf['check_rule_msg'];
        $params['is_sys_merge_order'] = $sdf['is_sys_merge_order'];
        $params['merge_order_cycle'] = $sdf['merge_order_cycle'];
        
        $title = '同步订单流转处理规则';
        $callback = array(
            'class' => get_class($this),
            'method' => 'callback',
            'params' => $params
        ); 
        $rs = $this->__caller->call(STORE_CN_RULE,$params,$callback,$title,10,$this->__channelObj->channel['shop_id']);
        return $rs;
    }

    public function searchAddress($rdef)
    {
        $shop_id = $this->__channelObj->channel['shop_id'];
        $data = array('shop_id' => $this->__channelObj->channel['shop_id'],'shop_type'=> $this->__channelObj->channel['shop_type'],'obj_bn'=>$this->__channelObj->channel['shop_id']);
        $params = array(
            'search_type'=>$rdef,    
        );
        
        $callback = array(
            'class' => get_class($this),
            'method' => 'searchAddress_callback',
            'params' => $data
        );
        $title = '店铺('.$this->__channelObj->channel['name'].')获取地址库列表';

        $this->__caller->call(SHOP_LOGISTICS_ADDRESS_SEARCH,$params,$callback,$title,10,$this->__channelObj->channel['shop_id']);
    }


    public function searchAddress_callback($response, $callback_params){
        
        $oAddress = app::get('ome')->model('return_address');
        $shop_id = $callback_params['shop_id'];
        $rsp = $response;
        if ($rsp['rsp']=='succ' && $shop_id) {
            $address_list = json_decode($rsp['data'],true);
             $address_list= $address_list['address_result'];
            //保存至本地
            if ($address_list) {
                foreach ($address_list as $list ) {
                    $data = array(
                        'cancel_def'    =>$list['cancel_def'],
                        'city'          =>$list['city'],
                        'area_id'       =>$list['area_id'],
                        'phone'         =>$list['phone'],
                        'mobile_phone'  =>$list['mobile_phone'],
                        'province'      =>$list['province'],
                        'addr'          =>$list['addr'],
                        'country'       =>$list['country'],
                        'contact_id'    =>$list['contact_id'],
                        'get_def'       =>$list['get_def'],
                        'contact_name'  =>$list['contact_name'],
                        'seller_company'=>$list['seller_company'],
                        'send_def'      =>$list['send_def'],
                        'zip_code'      =>$list['zip_code'],
                        'shop_type'     =>$callback_params['shop_type'],
                        'shop_id'       =>$shop_id,
                    );
                    $re = $oAddress->db->selectrow('SELECT count(1) AS num FROM sdb_ome_return_address WHERE shop_id="'.$shop_id.'" and area_id="'.$list['area_id'].'"'); 
                    $filter = array(
                            'shop_id'=>$shop_id,
                            'area_id'=>$list['area_id']
                    );
                    if($re['num']<=0){
                        $rp = $oAddress->save($data);  
                    }   
                    else{
                        //$rp = $oAddress->update($data,$filter);
                        $rp = $oAddress->delete($filter);  
                        $rp = $oAddress->save($data);  
                    }
                    
                }
            }
            
        } 
        return $this->callback($response, $callback_params);    
    }

    public function updateReturnLogistics($reshipinfo) {}

    /**
     * 批量获取云栈大头笔信息
     * @param   array  $datas    发货单信息
     * @param   string $cp_code  物流公司编号
     * @return  object $res      返回信息结果
     * @access  public
     * @author  liuzecheng@shopex.cn
     */
    public function getCloudStackPrintTags($datas,$cp_code) {
        $params = array(
            'cp_code' => $cp_code,
        );
        foreach ($datas as $data) {
            $address_pairs = array(
                'shipping_address'=>array(
                    'area'=>$data['dly_area_2'],
                    'province'=>$data['dly_area_0'],
                    'town'=>'',
                    'city'=>$data['dly_area_1'],
                    'address_detail'=>$data['dly_address'],
                ),
                //订单号非必须参数
                'trade_order_code'=> $data['delivery_bn'],
                //收货人地址
                'consignee_address'=> array(
                    'area'=>$data['ship_area_2'],
                    'province'=>$data['ship_area_0'],
                    'town'=> '',
                    'city'=>$data['ship_area_1'],
                    'address_detail'=> $data['ship_addr'],
                ),
                //物流单号非必须参数（暂时屏蔽）
                // 'waybill_code'=> ''
            );
            $address_pairss[] = $address_pairs;
        }
        $params['address_pairs'] = json_encode($address_pairss);
        $title = '获取（' . $cp_code . '）的' . '云栈大头笔';
        // 记录获取云栈大头笔日志
        $result = $this->__caller->call(SHOP_GET_CLOUD_STACK_PRINT_TAG, $params, array(), $title, 20);
        return $result;
    }

    /**
     * 获取物流可不可达
     *
     * @return void
     * @author 
     **/
    public function getAddressReachable($sdf)
    {
        $params = array();

        $result = $this->__caller->call(LOGISTICS_SERVICE_AREAS_ALL_GET, $params, array(), '物流可不可达', 6);

        return $result;
    }

    #获取跨境物流
    public function crossbordercorp($sdf){
        $param['type'] = 'OFFLINE';# ONLINE或者
        $param['from_id'] = $sdf['region_id'];# 发货地区域id
        $param['to_address'] =  json_encode($sdf['to_address']);  # 收件人地址
        $param['shop_id'] =  $this->__channelObj->channel['shop_id'];

        $title = '店铺('.$this->__channelObj->channel['name'].')直邮获取跨境资源列表'; 
        $result = $this->__caller->call(SHOP_WLB_THREEPL_RESOUCE_GET, $param, '', $title, 10);   
        return $this->back_crossbordercorp($result,$param);
    }
    public function back_crossbordercorp($response, $callback_params){
        $obj_dly_corp = app::get('ome')->model('dly_corp');
        $shop_id = $callback_params['shop_id'];
        $rsp = $response;
        if ($rsp['rsp']== 'succ' && $shop_id) {
             $data = json_decode($rsp['data'],true);
             $corp_list = $data['result']['resources']['three_pl_consign_resource_dto'];
            $all_crossborder_res_id = $obj_dly_corp->getList('crossborder_res_id',array('crossborder_souce'=>$shop_id,'is_crossborder'=>'true','crossborder_region_id'=>$callback_params['from_id']));
            $all_crossborder_res_id = array_map('current', $all_crossborder_res_id);
            //保存至本地
            if ($corp_list) {
                foreach ($corp_list as $list ) {
                    $res_id = number_format($list['res_id'],0,'','');
                    #已经存在的res_id，过滤掉
                    if(in_array($res_id, $all_crossborder_res_id))continue;
                    $data = array (
                        'all_branch' => 'true',#默认是适用所有仓库
                        'tmpl_type' => 'normal',
                        'name' => $list['res_name'],
                        'type' => $list['res_code'],
                        'setting' => '1',#统一地区
                        'firstunit' =>  $list['basic_weight']?$list['basic_weight']:0,#首重
                        'firstprice' => $list['basic_weight_price']?$list['basic_weight_price']:0,#首重价格
                        'continueunit' => $list['step_weight']?$list['step_weight']:0,#续重
                        'continueprice' => $list['step_weight_price']?$list['step_weight_price']:0,#续重价格
                        'corp_type' => 1,#1是跨境
                        'crossborder_res_id'=>$res_id,
                        'crossborder_souce'=>$shop_id,
                        'crossborder_region_id'=>$callback_params['from_id']
                    );
                    $obj_dly_corp->save($data);
                }
            }
        }else{
            $err_msg = json_decode($rsp['msg'],true);
            if(!empty($err_msg)){
                $rsp['msg'] = $err_msg['result']['error_msg'];
            }else{
                $rsp['msg'] = $rsp['msg'];
            }
        }
        return $rsp;
    } 
}