<?php
class ome_ctl_admin_batch_order extends desktop_controller{
    var $name = "订单中心";
    var $workground = "order_center";

    
    /**
     * 批量审核订单
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    function batchConfirm()
    {

        $corpObj      = app::get('ome')->model('dly_corp');
        $branchObj  = app::get('ome')->model('branch');
        $orderObj    = app::get('ome')->model('orders');
        $branchList = $branchObj->db->select('SELECT branch_id,name FROM sdb_ome_branch WHERE b_type=\'1\' AND disabled=\'false\' AND is_deliv_branch=\'true\'');
        $arrBranchId[] = 0;
        foreach($branchList as $val){
            $arrBranchId[] = $val['branch_id'];
        }
        $corpList = $corpObj->getList('branch_id, all_branch, corp_id, name, type, is_cod, weight, channel_id, shop_id, tmpl_type', array('disabled' => 'false', 'branch_id' => $arrBranchId,'d_type'=>'1'), 0, -1, 'weight DESC');
        $order_ids = $_POST['order_id'];
       
        $orders = $orderObj->getList('order_id',array('order_id'=>$order_ids,'process_status'=>array('unconfirmed','confirmed'),'order_confirm_filter' => '((is_cod=\'true\' or pay_status in (\'1\',\'4\',\'5\')))', 'status' => 'active', 'ship_status' => '0', 'f_ship_status' => '0',  'abnormal' => 'false', 'is_auto' => 'false', 'is_fail' => 'false','pause'=>'false'));
        $orderGroup = array();
        foreach ( $orders as $order ) {
            $orderGroup[] = $order['order_id'];
        }
        $this->pagedata['finder_id'] = $_GET['finder_id'];
        $this->pagedata['ordercount'] = count($orderGroup);
        $this->pagedata['orderGroup'] = json_encode($orderGroup);
        $this->pagedata['currentTime'] = time();
        $this->pagedata['ordertotal'] = count($order_ids);
        $this->pagedata['corpList'] = $corpList;
        $this->pagedata['branchList'] = $branchList;
        unset($corpList,$branchList,$orderGroup);

        $this->display('admin/batch/confirm.html');
    }

    
    /**
     * 自动审核订单.
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    function ajaxDoAuto()
    {
        $combineObj = kernel::single('omeauto_auto_combine');
        $oOrder = app::get('ome')->model('orders');
        $batch_orderObj = kernel::single('ome_batch_order');
        $group = kernel::single('omeauto_auto_group_item');
        $branch_id = $_POST['branch_id'];
        $corp_id = $_POST['corp_id'];
        $corps = app::get('ome')->model('dly_corp')->dump($corp_id, 'corp_id, name, type, is_cod, weight');
        $result = array('total' => 0, 'succ' => 0, 'fail' => 0);
        $ajaxParams = explode(';',$_POST['ajaxParams']);
        $rows = $oOrder->getList('*', array('order_id' => $ajaxParams));
        $orders = array();
        foreach ($rows as $order) {
            $orders[$order['order_id']] = $order;
            
        }
        unset($rows);
        foreach ( $orders as $order ) {
            $order_id = $order['order_id'];
            $result['total'] ++;
            $consignee['branch_id'] = $branch_id;
            $consignee['oper_source'] = '批量:';
            //验证库存
            $product_store = $batch_orderObj->getBranchStore($order_id,$branch_id);
            //验证到不到
            $arrived = $batch_orderObj->get_arrived($order,$corps);

            if ($product_store && $arrived) {
                $deliveryresult =  $combineObj->mkDelivery($order_id, $consignee, $corp_id);
            
                if ($deliveryresult) {
                    $result['succ'] ++;
                }else{
                    $result['fail']++;
                }
            }else{
                $msgFlag = array();
                if ($orders['auto_status']>0) {
                    $msgFlag[] =$orders['auto_status'];
                }
                
                
                if (!$arrived) {
                    $msgFlag[] = omeauto_auto_const::_LOGIST_ARRIVED;
                }
                if (!$product_store) {
                    $msgFlag[] = omeauto_auto_const::__STORE_CODE;
                }
                
                $auto_status =implode('|',$msgFlag);

                $oOrder->db->exec("UPDATE sdb_ome_orders SET auto_status='".$auto_status."' WHERE order_id=".$order_id);
                $result['fail']++;
            }
            
        }
        echo json_encode($result,true);
    }

    /**
     * 批量取消订单.
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    public function batchCancel(){
       $order_ids = $_POST['order_id'];
       $orderObj    = app::get('ome')->model('orders');
       $orders = $orderObj->getList('order_id',array('order_id'=>$order_ids,'payed'=>0,'status|notin'=>array('dead')));
       $orderGroup = array();
       foreach ( $orders as $order ) {
           $orderGroup[] = $order['order_id'];
       }
       $this->pagedata['finder_id'] = $_GET['finder_id'];
       $this->pagedata['ordercount'] = count($orderGroup);
       $this->pagedata['orderGroup'] = json_encode($orderGroup);
       $this->pagedata['currentTime'] = time();
       $this->pagedata['ordertotal'] = count($order_ids);

       unset($orderGroup);
       $this->display("admin/batch/cancel.html");
    }

    /**
     * 批量取消订单.
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    public function doBatchCancel(){
        $oOrder = app::get('ome')->model('orders');
        $oShop = $this->app->model('shop');
        $result = array('total' => 0, 'succ' => 0, 'fail' => 0);
        $ajaxParams = explode(';',$_POST['ajaxParams']);
        $rows = $oOrder->getList('shop_id,order_id,source', array('order_id' => $ajaxParams,'payed'=>0,'status|notin'=>array('dead')));
        $orders = array();
        foreach ($rows as $order) {
            $orders[$order['order_id']] = $order;

        }
        unset($rows);
        foreach ( $orders as $order ) {
        $order_id = $order['order_id'];
        $result['total'] ++;

        $memo = "批量取消订单: ".$_POST['memo'];
        $mod = 'sync';

        $c2c_shop_list = ome_shop_type::shop_list();
        $shop_detail = $oShop->dump(array('shop_id'=>$order['shop_id']),'node_id,node_type');
        if(!$shop_detail['node_id'] || in_array($shop_detail['node_type'],$c2c_shop_list) || $order['source'] == 'local'){
            $mod = 'async';
        }

        $sync_rs = $oOrder->cancel($order_id,$memo,true,$mod);
        if($sync_rs['rsp'] == 'success')
        {
            $result['succ'] ++;
        }else{
            $result['fail']++;
        }



        }
        echo json_encode($result,true);
    }
   
    /**
     * 批量开发票.
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    public function BatchTax(){
        $this->_request = kernel::single('base_component_request');
        $obj_order = app::get('ome')->model('orders');
        $all_order_ids = array();
        if($_GET['is_tax'] == 'no'){
            $is_tax = 'true';
        }elseif($_GET['is_tax'] == 'yes'){
            $is_tax = 'false';
        }
      
        if(isset($_POST['isSelectedAll']) && $_POST['isSelectedAll']){
           
            if($_GET['type'] == 'active'){
                $filter = array(
                    'disabled' => 'false',
                    'is_fail' => 'false',
                    'status' => 'active',
                    'archive' => 0,
                    'process_status|noequal' => 'is_declare',
                );
            }elseif($_GET['type'] == 'unmyown'){
            
                $filter = array (
                    'assigned' => 'assigned',
                    'abnormal' => 'false',
                    'is_fail' => 'false',
                    'status' => 'active',
                    'process_status' =>array (
                        0 => 'unconfirmed',
                        1 => 'confirmed',
                        2 => 'splitting',
                    ),
                    'archive' => 0,
                );
            }
            $_order_ids = $obj_order->getList('order_id',$filter);
            foreach($_order_ids as $val){
                $all_order_ids[] = $val['order_id'];
            }
        }else{
            $order_ids = $_POST['order_id'];
            foreach($order_ids as $order_id){
                $all_order_ids[] = $order_id;
            }
        }
        if(app::get('invoice')->is_installed()){
            $this->pagedata['invoice'] =  'true'; 
        }else{
            $this->pagedata['invoice'] =  'false';
        }
        $this->pagedata['is_tax'] =  $is_tax;
    
        $this->pagedata['order_num'] = count($all_order_ids);
        $this->pagedata['order_id'] = $all_order_ids;
        $this->pagedata['all_order_ids'] = json_encode($all_order_ids);
        $this->display('admin/order/batch/tax.html');
    }
    
    /**
     * 批量开发票.
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    public function doBatchTax(){
        $order_id = $_POST['order_id'];
        $is_tax = $_POST['is_tax'];

        $orderObj = app::get('ome')->model('orders');
        $oOperation_log = app::get('ome')->model('operation_log');
        if(app::get('invoice')->is_installed()){
            //安装了app invoice
            if($is_tax == 'true'){
                //是否开票 选择 是 做新建发票记录操作
                $arr_create_invoice = array(
                    'order_id'=>$order_id,
                    'invoice_mode'=>$post_data['invoice_mode'],
                );

                kernel::single('invoice_process')->create($arr_create_invoice,"order_detail_basic");
                $order_is_tax_part = "开发票";
            }else{
                //是否开票 选择 否 做发票作废操作
                $arr_cancel_invoice = array('order_id'=>$order_id);
                kernel::single('invoice_process')->cancel($arr_cancel_invoice,"order_detail");
                $order_is_tax_part = "不开发票";
            }
            //更新订单is_tax字段 并记下log
            $update_arr = array("is_tax"=>$is_tax);
            $filter_arr = array("order_id"=>$order_id);
            $rs_is_tax = $orderObj->update($update_arr,$filter_arr);
            $order_is_tax_log = "批量设置订单更新为".$order_is_tax_part;
            if($rs_is_tax){
                $oOperation_log->write_log('order_modify@ome',$order_id,$order_is_tax_log);
            }
        }else{
            //未安装app:invoice的 只对ome_orders表做相应字段更新
            $data = array(
                'order_id' => $order_id,
                'is_tax' => $_POST['is_tax'],
            );
            $oOrders->save($data);
            $oOperation_log->write_log('order_modify@ome',$order_id,'录入及变更发票号');
        }
        
        echo json_encode(array('status'=>'success')); die;
    }

    /**
     * 批量操作对话框
     *
     * @return void
     * @author 
     **/
    public function batchDialog($act,$flt,$view)
    {
        if ($act == 'renew') {
            $this->pagedata['dailogform'] = false;
        }
        $orderCtl = kernel::single('ome_ctl_admin_order');
        // 条件
        switch ($act) {
            case 'dopause':
                $base_filter = array('pause'=>'false','archive'=>'0');
                if ($flt == 'unmyown') {
                    $base_filter['op_id']          = kernel::single('desktop_user')->get_id();
                    $base_filter['assigned']       = 'assigned';
                    $base_filter['abnormal']       = "false";
                    $base_filter['is_fail']        = 'false';
                    $base_filter['status']         = 'active';
                    $base_filter['process_status'] = array('unconfirmed', 'confirmed', 'splitting');

                    if ($view == 989898) {
                        $base_filter['is_cod'] = 'true';
                    } elseif ($view && $view<999000) {
                        $base_filter['order_confirm_filter'] = sprintf("(sdb_ome_orders.auto_status & %s = %s)", $view, $view);
                    }

                } elseif ($flt == 'active') {
                    $sub_menu = $orderCtl->_view_active();
                    foreach ($sub_menu as $key => $value) {
                        if($view == $key){
                            $base_filter = array_merge((array)$value['filter'], $base_filter);
                        }
                    }
                }

                if(kernel::single('desktop_user')->is_super()){
                    unset($base_filter['op_id']);
                }

                $filter = array_merge((array)$_POST , (array)$base_filter);

                break;
            case 'renew':
                // 一单一单处理
                $base_filter = array('pause'=>'true','archive'=>'0');
                if ($flt == 'unmyown') {
                    $sub_menu = $orderCtl->_views_unmyown();
                    foreach ($sub_menu as $key => $value) {
                        if($view == $key){
                            $base_filter = array_merge((array)$value['filter'], $base_filter);
                        }
                    }

                } elseif ($flt == 'active') {
                    $sub_menu = $orderCtl->_view_active();
                    foreach ($sub_menu as $key => $value) {
                        if($view == $key){
                            $base_filter = array_merge((array)$value['filter'], $base_filter);
                        }
                    }
                }

                if(kernel::single('desktop_user')->is_super()){
                    unset($base_filter['op_id']);
                }

                $filter = array_merge((array)$_POST , (array)$base_filter);

                break;
            case 'doabnormal': //批量设置为异常
                $base_filter = array('archive'=>'0');
                if ($flt == 'unmyown') {
                    $base_filter['op_id']          = kernel::single('desktop_user')->get_id();
                    $base_filter['assigned']       = 'assigned';
                    $base_filter['abnormal']       = "false";
                    $base_filter['is_fail']        = 'false';
                    $base_filter['status']         = 'active';
                    $base_filter['process_status'] = array('unconfirmed', 'confirmed', 'splitting');

                    if($view>=999000){
                        $filter_parames = array('model'=>'ome_mdl_orders','user_id'=>$base_filter['op_id'],'app'=>'ome','ctl'=>'admin_order','act'=>'confirm');
                        $filterobj=app::get('desktop')->model('filter');
                        $confirm_filter = $filterobj->getFilter($filter_parames,$view);
                        $base_filter = array_merge((array)$base_filter,(array)$confirm_filter);
                    }else{
                        $sub_menu = $orderCtl->_views_unmyown();
                        foreach ($sub_menu as $key => $value) {
                            if($view == $key){
                                $base_filter = array_merge((array)$value['filter'], $base_filter);
                            }
                        }
                    }
                     
                } elseif ($flt == 'active') { 
                    $base_filter['disabled']       = 'false';
                    $base_filter['is_fail']        = 'false';
                    $base_filter['status']         = 'active';
                    if($view>=999000){
                        $filter_parames = array('model'=>'ome_mdl_orders','user_id'=>$base_filter['op_id'],'app'=>'ome','ctl'=>'admin_order','act'=>'active');
                        $filterobj=app::get('desktop')->model('filter');
                        $confirm_filter = $filterobj->getFilter($filter_parames,$view);
                        $base_filter = array_merge((array)$base_filter,(array)$confirm_filter);
                    }else{
                        $sub_menu = $orderCtl->_view_active();
                        foreach ($sub_menu as $key => $value) {
                            if($view == $key){
                                $base_filter = array_merge((array)$value['filter'], $base_filter);
                            }
                        }
                    }
                }
                $op_id = kernel::single('desktop_user')->get_id();
                $groupObj = $this->app->model("groups");
                $op_group = $groupObj->get_group($op_id);
                if(kernel::single('desktop_user')->is_super()){
                    unset($base_filter['op_id']);
                    unset($op_group['group_id']);
                    unset($op_id);
                }
                $filter = array_merge((array)$_POST,(array)$base_filter);
                $this->pagedata['dialogform'] = true;
                $abnormalTypeModel = $this->app->model('abnormal_type');
                $abnormal_type = $abnormalTypeModel->getList("*");
                $this->pagedata['abnormal_type'] = $abnormal_type;
                break;
            default:
                echo "系统无法识别你的批量操作";exit;
                break;
        }

        $orderModel = app::get('ome')->model('orders');
        $count = $orderModel->count($filter);

        $this->pagedata['total'] = $count;
        $this->pagedata['filter'] = http_build_query($filter);
        $this->pagedata['act']  = $act;
        $this->pagedata['flt']  = $flt;
        $this->pagedata['view'] = $view;

        $this->display('admin/order/batch/dialog.html');
    }


    /**
     * 针对订单
     * 所有的批量操作都应该放这里
     *
     * @return void
     * @author 
     **/
    public function batchopt($act,$flt,$view)
    {
       
        $result = true; $msg = '操作成功';
        // 订单
        $orderModel = app::get('ome')->model('orders');
        $filter = array();
        switch ($act) {
            //批量暂停
            case 'dopause':
                $page_no = intval($_GET['page_no']) ? intval($_GET['page_no']) : 1;
                $page_size = 10;
                $offset = 0;
                $total = intval($_GET['total']);
                parse_str($_POST['filter'],$filter);

                $orders = $orderModel->getList('order_id',$filter, $offset, $page_size);

                $succ_num = $fail_num = 0;
                if ($orders) {
                    foreach ((array) $orders as $order) {
                        $rs = $orderModel->pauseOrder($order['order_id']);

                        if ($rs) $succ_num++; else $fail_num++;
                    }
                }

                $result = array('status'=>'running','data'=>array('succ_num'=>$succ_num,'fail_num'=>$fail_num));

                if ( ($page_size * $page_no) >= $total) {
                    $result['status'] = 'complete';
                    $result['data']['rate'] = '100';
                } else {
                    $result['data']['rate'] =  $page_no * $page_size / $total * 100;
                }

                echo json_encode($result);exit;

                break;
            //批量恢复
            case 'renew':
                $page_no = intval($_GET['page_no']) ? intval($_GET['page_no']) : 1;
                $page_size = 10;
                $offset = 0;
                $total = intval($_GET['total']);
                parse_str($_POST['filter'],$filter);

                $orders = $orderModel->getList('order_id',$filter,$offset,$page_size);

                $succ_num = $fail_num = 0;
                if ($orders) {
                    foreach ((array) $orders as $order) {
                        $rs = $orderModel->renewOrder($order['order_id']);
                        if ($rs) $succ_num++; else $fail_num++;
                    } 
                }

                $result = array('status'=>'running','data'=>array('succ_num'=>$succ_num,'fail_num'=>$fail_num));

                if ( ($page_size * $page_no) >= $total) {
                    $result['status'] = 'complete';
                    $result['data']['rate'] = '100';
                } else {
                    $result['data']['rate'] =  $page_no * $page_size / $total * 100;
                }

                echo json_encode($result);exit;

                break;
            //批量设置为异常
            case 'doabnormal':
                $page_no = intval($_GET['page_no']) ? intval($_GET['page_no']) : 1;
                $page_size = 10;
                if($flt == 'unmyown'){
                    $offset = 0;
                }elseif ($flt == 'active'){
                    $offset = ($page_no-1)*$page_size;
                }
                $total = intval($_GET['total']);
                parse_str($_POST['filter'],$filter);
                $abnormal_data = $_POST['abnormal'];
                $orders = $orderModel->getList('order_id',$filter,$offset,$page_size);
                $succ_num = $fail_num = 0;
                $abnormalModel = $this->app->model('abnormal');
                if ($orders) {
                    foreach ((array) $orders as $order) {
                        $abnormal_data['order_id'] = $order['order_id'];
                        $abnormal = $abnormalModel->dump(array("order_id"=>$order['order_id']),"abnormal_id");
                        if(!empty($abnormal)) $abnormal_data['abnormal_id'] = $abnormal['abnormal_id'];
                        $orderModel->set_abnormal($abnormal_data);
                        unset($abnormal_data['order_id']);
                        unset($abnormal_data['abnormal_id']);
                        //取消发货单
                        define('FRST_TRIGGER_OBJECT_TYPE','发货单：订单异常取消发货单');
                        define('FRST_TRIGGER_ACTION_TYPE','ome_ctl_admin_order：do_abnormal');
                        $orderModel->cancel_delivery($order['order_id']);
                        $succ_num++;
                    } 
                }

                $result = array('status'=>'running','data'=>array('succ_num'=>$succ_num,'fail_num'=>$fail_num));

                if ( ($page_size * $page_no) >= $total) {
                    $result['status'] = 'complete';
                    $result['data']['rate'] = '100';
                } else {
                    $result['data']['rate'] =  $page_no * $page_size / $total * 100;
                }

                echo json_encode($result);exit;

                break;
            default:
                # code...
                break;
        }

    }
}
?>
